/**
    This is an abstract class that may be extended to define
    a DataElement as a node on a LinkedList. All
    methods are also abstract.
*/
public abstract class DataElement
{
    /** Returns true if this object's data matches
        other object's data; otherwise false
    */
    public abstract boolean equals( DataElement other );

    /** Returns < 0 if this element is less than
       the other element;
       Returns 0 if this element is the same as
       other
       Returns > 0 if this element is greater than
       the other element
       */
    public abstract int compareTo( DataElement other );

    /** Data of other element is copied into this
        element
    */
    public abstract void makeCopy( DataElement other );

    /**
    Returns a reference to a copy of this object
    */
    public abstract DataElement getCopy();

    /**
    Converts element data to a string format for output purposes.
    */
    public abstract String toString();
}