/*******************************************************************************
** Student.java
**
** Dan Strother
** 10/21/2003
** Computer Science 143
**
** Assignment #3
*******************************************************************************/

/**
	Implementation of a class representing a student who possesses both an
	identification number and a phone number (area code not specified).
*/
public class Student extends Person
{
	/** Student's identification number */
	private String			mID;
	/** Student's phone number */
	private String			mPhone;

	/**
		Default constructor. Initialize data to something.. default.
	*/
	public					Student()
	{
		super();

		mID			= "1337";
		mPhone		= "555-1234";
	}

	/**
		Param constructor.
	*/
	public					Student(String first, String last, String ID, String phone)
	{
		super(first, last);

		mID		= ID;
		mPhone	= phone;
	}

	/**
		Copy constructor.
	*/
	public					Student(Student other)
	{
		makeCopy((DataElement)other);
	}

	/** Gets the student's ID number. */
	public String			getIDNum()		{ return(mID); }

	/** Gets the student's phone number. */
	public String			getPhoneNum()	{ return(mPhone); }

	/** Sets the student's ID number. */
	public void				setIDNum(String ID)			{ mID = ID; }

	/** Sets the student's phone number. */
	public void				setPhoneNum(String phone)	{ mPhone = phone; }

    /**
    	Returns true if this student matches the other one;
    	false otherwise.
    */
    public boolean			equals(DataElement other)
    {
		// Validate param.
		if(other == null) return(false);

		// Check if super is the same.
		if(super.equals(other))
		{
			// Compare numbers to check for a match.
			if( ( ((Student)other).mID		== mID) &&
				( ((Student)other).mPhone	== mPhone) )
				return(true);
		}

		// Nope - not the same.
		return(false);
	}

    /**
    	Returns < 0 if this person is numerically earlier than the other.
    	Returns 0 if they are the same.
    	Returns > 0 if this person is numerically later than the other.
    */
    public int				compareTo(DataElement other)
    {
		// TODO : Implement this!

		return(super.compareTo(other));
	}

    /**
    	This student duplicates passed student.
    */
    public void				makeCopy(DataElement other)
    {
		// Validate param.
		if(other == null) return;

		super.makeCopy(other);

		// Copy intrinsic data.
		mID		= ((Student)other).mID;
		mPhone	= ((Student)other).mPhone;
	}

    /**
		Returns a reference to a copy of this student.
    */
    public DataElement		getCopy()
    {
		// Create a copy of this one.
		Student stdt = new Student(this);

		// Return the new one.
		return((DataElement)stdt);
	}

    /**
    	Converts element data to a string format for output purposes.
    */
    public String			toString()
    {
		return(super.toString() + " (SID: " + mID + ", Phone#: " + mPhone + ")");
	}
}